﻿#include "global.h"

FILE* LOGGER_FILE;

int loadMemTxtFile(const char* nameFile, unsigned int* arrayWords, int count) {
    int index = 0;
    FILE* file = fopen(nameFile, "r");
    char* str;
    if (file == NULL) {
        LOGGER_PRINT("Невозможно открыть MEM файл '%s'\n", nameFile);
        return BAD_CODE;
    }
    LOGGER_PRINT("парсинг '%s':\n", nameFile);
    while (!feof(file)) {
        if (index >= count)
            break;
        readline(file, &str);
        //LOGGER_PRINT("%s", str); // for debug
        unsigned int adr, w1, w2, w3, w4, w5, w6, w7, w8;
        int readedArgs = sscanf(str, "%x: %x %x %x %x %x %x %x %x", &adr, &w1, &w2, &w3, &w4, &w5, &w6, &w7, &w8);
        if (readedArgs != 9) {
            LOGGER_PRINT_STR(" - Парсинг окончен!\n");
            return GOOD_CODE;
        }
        //LOGGER_PRINT_STR("\n");
        arrayWords[index++] = w1;
        arrayWords[index++] = w2;
        arrayWords[index++] = w3;
        arrayWords[index++] = w4;
        arrayWords[index++] = w5;
        arrayWords[index++] = w6;
        arrayWords[index++] = w7;
        arrayWords[index++] = w8;
    }
    return GOOD_CODE;
}

void _readline(FILE* stream, char** line, int* count) {
    int ch = fgetc(stream);
    if ((ch == '\n') || (ch == EOF)) {
//        printf("end line - %d\n", *count);
        *line = (char *) malloc(*count + 1);
        (*line)[*count] = 0;
//        printf("down to up\n");
        return;
    } else {
        (*count)++;
//        printf("down - %d\n", *count);
        _readline(stream, line, count);
//        printf("up - %d\n", *count);
        (*line)[--(*count)] = ch;
    }
}


void readline(FILE* stream, char** line) {
    int count = 0;
    _readline(stream, line, &count);
}

void constructLogFilename(char* filename, int length, char* testname) {
    time_t rawtime;
    struct tm * timeinfo;
    time(&rawtime);
    timeinfo = localtime(&rawtime);
    snprintf(filename, length, "%s%s-%dy-%dm-%dd-%dh-%dm-%ds.txt", STR_LOGS, testname, \
             timeinfo->tm_year + 1900, timeinfo->tm_mon + 1, timeinfo->tm_mday, timeinfo->tm_hour, timeinfo->tm_min, timeinfo->tm_sec);
}

// Вывести информацию об устройстве
int printDeviceInfo(int milFd)
{
#ifndef _WIN32
    PCI_LOCATION pciLoc;
    if(GOOD_CODE == mil1553_getDevicePciInfo(milFd, &pciLoc))
    {
        printf("PCI device, location: %s\n", pciLoc.name);
    }
    else
    {
        ETH_LOCATION ethLoc;
        if(GOOD_CODE == mil1553_getDeviceEthInfo(milFd, &ethLoc))
        {
            printf("ETH device, location: %s\n", ethLoc.ip_address_and_port);
        }
        else
        {
            USB_LOCATION usbLoc;
            if(GOOD_CODE == mil1553_getDeviceUsbInfo(milFd, &usbLoc))
            {
                printf("USB device, id: %s\n", usbLoc.path);
            }
            else
            {
                printf("Unknown device!\n");
                return BAD_CODE;
            }
        }
    }
#endif
    return GOOD_CODE;
}

uint64_t getTimeStamp() {
    struct timeval tv;
    gettimeofday(&tv,NULL);
    return tv.tv_sec*(uint64_t)1000000+tv.tv_usec;
}
